Description

Problem Description: Key/value list allows a list of items for selection.  These item allow the name of the item to be changed while

retaining the id of the item.  When filtering on such an item, the id is used (in contrast to a normal list where the name is used). 

However, when the 'Link values to URL' option is used, the %value% expands to the name of the entry.  This prevents use of the

'Link values to URL' as a pre-defined filter on the item.

Solution: Modify 'Link values to URL' to support a new value %value_id% which expands to the id of the item.

Examples:

For Custom key/value list "IT System":

id=3 name="Mail server"

id=4 name="Database server"

Link values to URL:

value https://server.org/?it_system=%value% expands to https://server.org/?it_system=Mail server (existing behavior)

value https://server.org/?it_system=%value_id% expands to https://server.org/?it_system=3 (new behavior)

Items

Decide on name: is "value_id" the best to use for this?

Update code that generates links based on "Link values to URL" setting.

Update Redmine documentation http://www.redmine.org/projects/redmine/wiki/RedmineCustomFields

History

#1 - 2020-07-03 20:26 - Igor Timofeev

+1 no way to make the field clickable, like "target version".

Suggest also "key_id" for the name of the variable.

#2 - 2020-12-20 16:48 - Chris Lockwood

It would be great if this worked for multiple regex matches (I'm not talking groups) translating them into multiple links.

#3 - 2020-12-21 03:30 - Go MAEDA

I think the suggested "%value_id%" is only useful in very limited situations because admins cannot assign any id number they want to a value.
